=== modified file 'Makefile'
--- Makefile	2010-05-12 09:27:10 +0000
+++ Makefile	2010-05-17 18:24:44 +0000
@@ -67,6 +67,7 @@
 
 apidoc: compile $(API_INDEX)
 
+# Run by PQM.
 check_merge: $(PY)
 	[ `PYTHONPATH= bzr status -S database/schema/ | \
 		grep -v "\(^P\|pending\|security.cfg\|Makefile\|unautovacuumable\|_pythonpath.py\)" | wc -l` -eq 0 ]
@@ -86,7 +87,19 @@
 check: clean build
 	# Run all tests. test_on_merge.py takes care of setting up the
 	# database.
-	${PY} -t ./test_on_merge.py $(VERBOSITY)
+	${PY} -t ./test_on_merge.py $(VERBOSITY) $(TESTOPTS)
+
+# A version of 'make check' that applies modifications specifically for the
+# ec2 environment.
+ec2_check: clean build
+        # XXX mars 2010-05-17 bug=570380
+        # Disable the windmill test suite to prevent the whole system from
+        # hanging.  See bug 570380.
+        #
+        # Yes, this is code duplication.  If you conceive of a better
+        # solution in a less heated moment, then please replace this!
+	${PY} -t ./test_on_merge.py $(VERBOSITY) $(TESTOPTS) \
+		--layer='!WindmillLayer'
 
 jscheck: build
 	# Run all JavaScript integration tests.  The test runner takes care of
@@ -94,7 +107,7 @@
 	@echo
 	@echo "Running the JavaScript integration test suite"
 	@echo
-	bin/test $(VERBOSITY) --layer=WindmillLayer
+	bin/test $(VERBOSITY) $(TESTOPTS) --layer=WindmillLayer
 
 jscheck_functest: build
     # Run the old functest Windmill integration tests.  The test runner
@@ -107,7 +120,8 @@
 check_mailman: build
 	# Run all tests, including the Mailman integration
 	# tests. test_on_merge.py takes care of setting up the database.
-	${PY} -t ./test_on_merge.py $(VERBOSITY) --layer=MailmanLayer
+	${PY} -t ./test_on_merge.py $(VERBOSITY) $(TESTOPTS) \
+		--layer=MailmanLayer
 
 lint: ${PY}
 	@bash ./bin/lint.sh
@@ -437,7 +451,7 @@
 	mv lp-clustered.svg.tmp lp-clustered.svg
 
 PYDOCTOR = pydoctor
-PYDOCTOR_OPTIONS = 
+PYDOCTOR_OPTIONS =
 
 pydoctor:
 	$(PYDOCTOR) --make-html --html-output=apidocs --add-package=lib/lp \
@@ -447,7 +461,7 @@
 
 .PHONY: apidoc check tags TAGS zcmldocs realclean clean debug stop\
 	start run ftest_build ftest_inplace test_build test_inplace pagetests\
-	check check_merge \
+	check check_merge ec2_check \
 	schema default launchpad.pot check_merge_ui pull scan sync_branches\
 	reload-apache hosted_branches check_db_merge check_mailman check_config\
 	jsbuild jsbuild_lazr clean_js buildonce_eggs \

=== modified file 'lib/devscripts/ec2test/remote.py'
--- lib/devscripts/ec2test/remote.py	2010-04-29 15:07:51 +0000
+++ lib/devscripts/ec2test/remote.py	2010-05-17 18:24:44 +0000
@@ -277,7 +277,7 @@
 
     def build_test_command(self):
         """See BaseTestRunner.build_test_command()."""
-        command = ['make', 'check', 'VERBOSITY=' + self.test_options]
+        command = ['make', 'ec2_check', 'TESTOPTS=' + self.test_options]
         return command
 
 

